// Cubeの回転（角度値）（Processing側）
// 2017.12 nakayasu

import processing.serial.*; // シリアルライブラリの読み込み
Serial myPort;
int[] serialInArray = new int[2];
int serialCount = 0;
int xangle, yangle;
boolean firstContact = false;
 
void setup()
{
  size(640, 480, P3D);
  noStroke();
  colorMode(RGB, 1);
  printArray(Serial.list()); // コンソールにシリアルデバイスの表示
  String portName = Serial.list()[3]; //シリアルデバイスナンバー
  myPort = new Serial(this, portName, 9600);
}
 
void draw()
{
  background(0);
  translate(width/2, height/2, -30);
  rotateX(radians(-30+360*xangle/255));
  rotateZ(radians(-360*yangle/255));
  scale(100);
  beginShape(QUADS);
  fill(0, 1, 1); vertex(-1, 1, 1); fill(1, 1, 1); vertex( 1, 1, 1);
  fill(1, 0, 1); vertex( 1, -1, 1); fill(0, 0, 1); vertex(-1, -1, 1);
   
  fill(1, 1, 1); vertex( 1, 1, 1); fill(1, 1, 0); vertex( 1, 1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1); fill(1, 0, 1); vertex( 1, -1, 1);
   
  fill(1, 1, 0); vertex( 1, 1, -1); fill(0, 1, 0); vertex(-1, 1, -1);
  fill(0, 0, 0); vertex(-1, -1, -1); fill(1, 0, 0); vertex( 1, -1, -1);
   
  fill(0, 1, 0); vertex(-1, 1, -1); fill(0, 1, 1); vertex(-1, 1, 1);
  fill(0, 0, 1); vertex(-1, -1, 1); fill(0, 0, 0); vertex(-1, -1, -1);
   
  fill(0, 1, 0); vertex(-1, 1, -1); fill(1, 1, 0); vertex( 1, 1, -1);
  fill(1, 1, 1); vertex( 1, 1, 1); fill(0, 1, 1); vertex(-1, 1, 1);
   
  fill(0, 0, 0); vertex(-1, -1, -1); fill(1, 0, 0); vertex( 1, -1, -1);
  fill(1, 0, 1); vertex( 1, -1, 1); fill(0, 0, 1); vertex(-1, -1, 1);
  endShape();
}
 
void serialEvent(Serial myPort) {
  int inByte = myPort.read();
  if (firstContact == false) {
    if (inByte == 'A') {
      myPort.clear(); // clear the serial port buffer
      firstContact = true; // you've had first contact from the microcontroller
      myPort.write('A'); // ask for more
    }
  } else {
    // Add the latest byte from the serial port to array:
    serialInArray[serialCount] = inByte;
    serialCount++;
    if (serialCount > 1 ) {
      xangle = serialInArray[0];
      yangle = serialInArray[1];
      myPort.write('A'); // Send a capital A to request new sensor readings:
      serialCount = 0; // Reset serialCount:
    }
  }
}